**************************************************
*-- Author:       Michael Drozdov
*-- Description:  Demonstrate:
*--				  As it is possible to add MyTextbox class in Grid from code
*-- Used:         Setup.dbf from D:\Program Files\Microsoft Visual Studio\MSDN\99OCT\1033\SAMPLES\VFP98\data\Testdata.dbc
*-- Time Stamp:   02/13/01 11:21:02 PM
**************************************************

RELEASE goForm
PUBLIC goForm
goForm = CreateObject("form1")
IF TYPE('goForm') = 'O' AND !ISNULL(goForm)
	goForm.Show()
ELSE
	??CHR(7)
	MessageBox("Can not create form", 16, _SCREEN.Caption)	
ENDIF

**************************************************
*-- Form:         form1 (d:\myapp\vfp\frmsetupwithgrid.scx)
*-- ParentClass:  form
*-- BaseClass:    form
*-- Time Stamp:   02/13/01 11:21:02 PM
*
DEFINE CLASS form1 AS form

	Height = 250
	Width = 217
	DoCreate = .T.
	AutoCenter = .T.
	BorderStyle = 2
	Caption = "Form1"
	MaxButton = .F.
	Name = "Form1"

	ADD OBJECT grdsetup AS grid WITH ;
		ColumnCount = 1, ;
		Height = 200, ;
		Left = 12, ;
		RecordSource = "SETUP", ;
		RecordSourceType = 1, ;
		Top = 12, ;
		Width = 192, ;
		Name = "grdSetup", ;
		Column1.ControlSource = "SETUP.key_name", ;
		Column1.Name = "Column1"
		
	ADD OBJECT cmdexit AS commandbutton WITH ;
		Top = 216, ;
		Left = 132, ;
		Height = 25, ;
		Width = 73, ;
		FontSize = 8, ;
		Cancel = .T., ;
		Caption = "Cancel", ;
		Name = "cmdExit"

	PROCEDURE Load
		LOCAL lcFile, lcAlias
		lcFile = HOME(2)+'Tastrade\Data\setup.dbf'
		IF !FILE(lcFile)
			ACTIVATE SCREEN
			??CHR(7)
			MessageBox('Not found file: '+lcFile)
			RETURN .F.
		ENDIF
		lcAlias = JUSTSTEM(lcFile)
		IF !USED(lcAlias)
			USE (lcFile) IN 0 SHARED
			IF !USED(lcAlias)
				ACTIVATE SCREEN
				??CHR(7)
				MessageBox('Can not open file: '+lcFile)
				RETURN .F.
			ENDIF
		ENDIF
		SELECT (lcAlias)
	ENDPROC

	PROCEDURE Init
		WITH ThisForm.grdsetup
			WITH .column1
				.header1.Caption = "key_name"
			ENDWITH	
			.AddColumn(2)
			WITH .column2
				.header1.Caption = "value"
				.Bound = .F.
				.AddObject("MyTextBox1", "MyTextBox")
				.CurrentControl = "MyTextBox1"
				.ControlSource = "setup.value"
				WITH .MyTextBox1
					.ControlSource = "setup.value"
					.Visible = .T.
				ENDWITH
				.Bound = .T.
			ENDWITH
		ENDWITH		
	ENDPROC
	
	PROCEDURE Destroy
		IF !EMPTY(ALIAS())
			USE IN (ALIAS())
		ENDIF
	ENDPROC
	
	PROCEDURE cmdexit.Click
		ThisForm.Release()
	ENDPROC

ENDDEFINE
*
*-- EndDefine: form1
**************************************************

DEFINE CLASS MyTextBox AS textbox
	Name = "MyTextBox"
	PROCEDURE Valid
		WAIT WINDOW 'ValidEvent from MyTextBox' NOWAIT
		RETURN .T. 
	ENDPROC
ENDDEFINE

